<?php
// Classe : Gestion des form html.
// Fichier fourni par Eric MILLOZ (www.milloz.net) pour IntegSite
// Copyright 12/01/2014
// Utilisation dans le cadre de IntegSite.

class FormLien
{
    // Variable interne.
    private $Methode;
    private $UrlDestination;
    private $NomFormulaire = "";
    private $NomBox;  // Radio checkbox
    private $TypeBox;  // Radio checkbox

    private $Champs = array("Nom", "LibelleChamp", "Type", "Valeur", "Exemple",
        "Longueur", "Maxlongueur", "Obligatoire", "Grise", "Autofocus", "Pattern");

    private $lisibilite = "N";
    private $debug = "N";
    // Type de champ , variable $Type
    // button,checkbox,,color,date,datetime,datetime-local,email,file,hidden,image,month,number,password,radio,
    // range,reset,search,submit,tel,text,time,url,week

    function FormLien($method, $url, $nomFormulaire)
    {
        $this->NomFormulaire = $nomFormulaire;
        $this->Methode = $method;
        if ($url == "") {
            $this->UrlDestination = $_SERVER['PHP_SELF'];
        } else {
            $this->UrlDestination = $url;
        }
        $enctype = 'application/x-www-form-urlencoded';
        // Init le form
        // Si pas de methode alors juste lien.
        $texte = "";
        if ($this->Methode != "")
            echo "<form action=\"" . $this->UrlDestination . "\" method=\"" . $this->
                Methode . "\" name=\"" . $this->NomFormulaire . "\" enctype=\"" . $enctype . "\">";
    }

    function RetourneLibelleChamp($Libelle)
    {
        // Label
        if ($Libelle != "")
            $texte .= "<label>" . $Libelle . "</label>";
        return $texte;
    }

    // Ajoute un champs type input
    function AjouteChampInput($NatureChamp, $NomChamp, $LibelleChamp, $Type, $Valeur,
        $Exemple, $Longueur, $Maxlongueur, $Obligatoire, $Grise, $Autofocus,$Pattern)
    {
        $this->Champs['$NomChamp']['Nom'] = $NomChamp;
        $this->Champs['$NomChamp']['LibelleChamp'] = $LibelleChamp;
        $this->Champs['$NomChamp']['Type'] = $Type;
        $this->Champs['$NomChamp']['Valeur'] = $Valeur;
        $this->Champs['$NomChamp']['Exemple'] = $Exemple;
        $this->Champs['$NomChamp']['Longueur'] = $Longueur;
        $this->Champs['$NomChamp']['Maxlongueur'] = $Maxlongueur;
        $this->Champs['$NomChamp']['Obligatoire'] = $Obligatoire;
        $this->Champs['$NomChamp']['Grise'] = $Grise;
        $this->Champs['$NomChamp']['Autofocus'] = $Autofocus;
        $this->Champs['$NomChamp']['Pattern'] = $Pattern;
        if ($this->debug == "O") {

            echo "<br/>Champ(" . $this->Champs['$NomChamp']['Nom'] . ")=" . $this->Champs['$NomChamp']['Nom'];
            echo "<br/>Champ de Nature : " . $NatureChamp;
            if ($this->Champs['$NomChamp']['LibelleChamp']!="")  echo "<br/>Champ(\"LibelleChamp\")=" . $this->Champs['$NomChamp']['LibelleChamp'];
            if ($this->Champs['$NomChamp']['Type']!="")  echo "<br/>Champ(\"Type\")=" . $this->Champs['$NomChamp']['Type'];
            if ($this->Champs['$NomChamp']['Valeur']!="")  echo "<br/>Champ(\"Valeur\")=" . $this->Champs['$NomChamp']['Valeur'];
            if ($this->Champs['$NomChamp']['Exemple']!="")  echo "<br/>Champ(\"Exemple\")=" . $this->Champs['$NomChamp']['Exemple'];
            if ($this->Champs['$NomChamp']['Longueur']!="")  echo "<br/>Champ(\"Longueur\")=" . $this->Champs['$NomChamp']['Longueur'];
            if ($this->Champs['$NomChamp']['Maxlongueur']!="")  echo "<br/>Champ(\"Maxlongueur\")=" . $this->Champs['$NomChamp']['Maxlongueur'];
            if ($this->Champs['$NomChamp']['Obligatoire']!="")  echo "<br/>Champ(\"Obligatoire\")=" . $this->Champs['$NomChamp']['Obligatoire'];
            if ($this->Champs['$NomChamp']['Grise']!="")  echo "<br/>Champ(\"Grise\")=" . $this->Champs['$NomChamp']['Grise'];
            if ($this->Champs['$NomChamp']['Autofocus']!="")  echo "<br/>Champ(\"Autofocus\")=" . $this->Champs['$NomChamp']['Autofocus'];
            if ($this->Champs['$NomChamp']['Pattern']!="")  echo "<br/>Champ(\"\Pattern\")=" . $this->Champs['$NomChamp']['Pattern'];
            echo "<br/>";
        }
        // Label
        $texte = "";
        if ($this->Champs['$NomChamp']['LibelleChamp'] != "") $texte .= "<label>" . $this->Champs['$NomChamp']['LibelleChamp'] . "</label>";
        $texte .= "<" . $NatureChamp . " name=\"" . $this->Champs['$NomChamp']['Nom'] . "\"";
        $texte .= " id=\"" . $this->NomFormulaire . "_" . $this->Champs['$NomChamp']['Nom'] . "\"";
        $texte .= " type=\"" . $this->Champs['$NomChamp']['Type'] . "\"";
        if ($this->Champs['$NomChamp']['Exemple'] != "")  $texte .= " placeholder=\"" . $this->Champs['$NomChamp']['Exemple'] . "\"";
        if ($this->Champs['$NomChamp']['Longueur'] != "") $texte .= " size=\"" . $this->Champs['$NomChamp']['Longueur'] . "\"";
        if ($this->Champs['$NomChamp']['Maxlongueur'] != "")  $texte .= " maxlength=\"" . $this->Champs['$NomChamp']['Maxlongueur'] . "\"";
        if ($this->Champs['$NomChamp']['Valeur'] != "") $texte .= " value=\"" . $this->Champs['$NomChamp']['Valeur'] . "\"";
        if ($this->Champs['$NomChamp']['Grise'] == "O") $texte .= " disabled";
        if ($this->Champs['$NomChamp']['Obligatoire'] == "O") $texte .= " required";
        if ($this->Champs['$NomChamp']['Autofocus'] == "O") $texte .= " autofocus";
        if ($this->Champs['$NomChamp']['Pattern'] != "") $texte .= " pattern=\"" . $this->Champs['$NomChamp']['Pattern'] . "\"";
        $texte .= "/>";
        return $texte;
    }

    function FormXBoxInit($Type,$Nom)
    {
      $this->TypeBox=$Type;
      $this->NomBox=$Nom;
    }
    function FormXBox($Valeur,$Libelle,$ParDefaut)
    {    
      $texte="<input type=\"".$this->TypeBox."\" value=\"".$Valeur."\" name=\"".$this->NomBox."\"";
      if ($ParDefaut=="O")  $texte.= " checked";
      $texte.=">".$Libelle."<br>";
      return $texte;
    }

    // Ajoute un champs type textarea
    function AjoutePave($NomChamp, $LibelleChamp, $Valeur, $Exemple, $Maxlongueur, $Col,
        $Row, $Wrap, $Obligatoire, $Grise, $Autofocus)
    {
        $this->Champs['$NomChamp']['Nom'] = $NomChamp;
        $this->Champs['$NomChamp']['LibelleChamp'] = $LibelleChamp;
        $this->Champs['$NomChamp']['Type'] = $Type;
        $this->Champs['$NomChamp']['Valeur'] = $Valeur;
        $this->Champs['$NomChamp']['Exemple'] = $Exemple;
        $this->Champs['$NomChamp']['Maxlongueur'] = $Maxlongueur;
        $this->Champs['$NomChamp']['Col'] = $Col;
        $this->Champs['$NomChamp']['Row'] = $Row;
        $this->Champs['$NomChamp']['Wrap'] = $Wrap;
        $this->Champs['$NomChamp']['Obligatoire'] = $Obligatoire;
        $this->Champs['$NomChamp']['Grise'] = $Grise;
        $this->Champs['$NomChamp']['Autofocus'] = $Autofocus;
        if ($this->debug == "O") {
            echo "<br/>Champ de Nature : " . $NatureChamp;
            echo "<br/>Champ(" . $this->Champs['$NomChamp']['Nom'] . ")=" . $this->Champs['$NomChamp']['Nom'];
            echo "<br/>Champ(" . $this->Champs['$NomChamp']['LibelleChamp'] . ")=" . $this->Champs['$NomChamp']['LibelleChamp'];
            echo "<br/>Champ(" . $this->Champs['$NomChamp']['Type'] . ")=" . $this->Champs['$NomChamp']['Type'];
            echo "<br/>Champ(" . $this->Champs['$NomChamp']['Valeur'] . ")=" . $this->Champs['$NomChamp']['Valeur'];
            echo "<br/>Champ(" . $this->Champs['$NomChamp']['Exemple'] . ")=" . $this->Champs['$NomChamp']['Exemple'];
            echo "<br/>Champ(" . $this->Champs['$NomChamp']['Longueur'] . "=" . $this->Champs['$NomChamp']['Longueur'];
            echo "<br/>Champ(" . $this->Champs['$NomChamp']['Col'] . "=" . $this->Champs['$NomChamp']['Col'];
            echo "<br/>Champ(" . $this->Champs['$NomChamp']['Row'] . "=" . $this->Champs['$NomChamp']['Row'];
            echo "<br/>Champ(" . $this->Champs['$NomChamp']['Wrap'] . "=" . $this->Champs['$NomChamp']['Wrap'];
            echo "<br/>Champ(" . $this->Champs['$NomChamp']['Obligatoire'] . ")=" . $this->Champs['$NomChamp']['Obligatoire'];
            echo "<br/>Champ(" . $this->Champs['$NomChamp']['Grise'] . ")=" . $this->Champs['$NomChamp']['Grise'];
            echo "<br/>Champ(" . $this->Champs['$NomChamp']['Autofocus'] . ")=" . $this->Champs['$NomChamp']['Autofocus'];
        }
        $texte = "";
        if ($this->Champs['$NomChamp']['LibelleChamp'] != "") $texte .= "<label>" . $this->Champs['$NomChamp']['LibelleChamp'] . "</label>";
        $texte .= "<textarea name=\"" . $this->Champs['$NomChamp']['Nom'] . "\"";
        $texte .= " id=\"" . $this->NomFormulaire . "_" . $this->Champs['$NomChamp']['Nom'] ."\"";
        if ($this->Champs['$NomChamp']['Exemple'] != "")  $texte .= " placeholder=\"" . $this->Champs['$NomChamp']['Exemple'] . "\"";
        if ($this->Champs['$NomChamp']['Maxlongueur'] != "")  $texte .= " maxlength=\"" . $this->Champs['$NomChamp']['Maxlongueur'] . "\"";
        if ($this->Champs['$NomChamp']['Col'] != "")  $texte .= " cols=\"" . $this->Champs['$NomChamp']['Col'] . "\"";
        if ($this->Champs['$NomChamp']['Row'] != "")  $texte .= " rows=\"" . $this->Champs['$NomChamp']['Row'] . "\"";
        if ($this->Champs['$NomChamp']['Grise'] == "O") $texte .= " disabled";
        if ($this->Champs['$NomChamp']['Obligatoire'] == "O") $texte .= " required";
        if ($this->Champs['$NomChamp']['Autofocus'] == "O") $texte .= " autofocus";
        $texte .= "/>";
        if ($this->Champs['$NomChamp']['Valeur'] != "") $texte .= $this->Champs['$NomChamp']['Valeur'];
        $texte .= "</textarea>";
        return $texte;
    }

    // Génère un cadre FieldSet
    function Cadre($Nom)
    {
        if ($Nom != "") {
            echo "<fieldset><legend>$Nom</legend>";
        } else {
            echo "</fieldset>";
        }
    }
    
    // Reset le formulaire.
    function BoutonResetFormulaire()
    {
        $texte = "<input type=\"button\" Name=\"Reset\" Value=\"Reset\" onClick=\"clearForm(this.form);\">";
        return $texte;
    } 

    // Insert un bouton.
    function ValidationParBouton($Nom, $Libelle)
    {
        $texte = "<input type=\"submit\" name=\"" . $Libelle . "\" ";
        if ($Nom != "")
            $texte .= "value=\"" . $Nom . "\"";
        $texte .= "/>";
        return $texte;
    }

    //<input type=BUTTON value="Submit" name="mySubmit" onClick="setText()">
    function ValidationParBouton1Champ($Nom, $Libelle, $Variable, $Valeur)
    {
        $texte = "<input type=\"button\" name=\"" . $Libelle . "\" ";
        if ($Nom != "")
            $texte .= "value=\"" . $Nom . "\"";
        $texte .= " onClick=\"javascript:document.forms." . $this->NomFormulaire . "." .
            $Variable . ".value='" . $Valeur . "';document.forms." . $this->NomFormulaire .".submit()\"";
        $texte .= "/>";
        return $texte;
    }
        
    function ValidationParBouton2Champs($Nom, $Libelle, $Variable1, $Valeur1, $Variable2, $Valeur2)
    {
        $texte = "";
        if ($Nom != "") {
          $texte .= "<input type=\"button\" name=\"" . $Libelle . "\" ";
          $texte .= "value=\"" . $Nom . "\"";
          $texte .= " onClick=\"javascript:document.forms." . $this->NomFormulaire . "." .$Variable1 . ".value='" . $Valeur1 . "';";
          $texte .= "document.forms." . $this->NomFormulaire . "." .$Variable2 . ".value='" . $Valeur2 . "';";
          $texte.="document.forms." . $this->NomFormulaire .".submit()\"";
          $texte .= "/>";
        }
        return $texte;
    }
    
    function ValidationParBouton3Champs($Nom, $Libelle, $Variable1, $Valeur1, $Variable2, $Valeur2, $Variable3, $Valeur3)
    {
        $texte = "";
        if ($Nom != "") {
          $texte .= "<input type=\"button\" name=\"" . $Libelle . "\" ";
          $texte .= "value=\"" . $Nom . "\"";
          $texte .= " onClick=\"javascript:document.forms." . $this->NomFormulaire . "." .$Variable1 . ".value='" . $Valeur1 . "';";
          $texte .= "document.forms." . $this->NomFormulaire . "." .$Variable2 . ".value='" . $Valeur2 . "';";
          $texte .= "document.forms." . $this->NomFormulaire . "." .$Variable3 . ".value='" . $Valeur3 . "';";
          $texte.="document.forms." . $this->NomFormulaire .".submit()\"";
          $texte .= "/>";
        }
        return $texte;
    }

    function ValidationParBouton4Champs($Nom, $Libelle, $Variable1, $Valeur1, $Variable2, $Valeur2, $Variable3, $Valeur3, $Variable4, $Valeur4)
    {
        $texte = "";
        if ($Nom != "") {
          $texte .= "<input type=\"button\" name=\"" . $Libelle . "\" ";
          $texte .= "value=\"" . $Nom . "\"";
          $texte .= " onClick=\"javascript:document.forms." . $this->NomFormulaire . "." .$Variable1 . ".value='" . $Valeur1 . "';";
          $texte .= "document.forms." . $this->NomFormulaire . "." .$Variable2 . ".value='" . $Valeur2 . "';";
          $texte .= "document.forms." . $this->NomFormulaire . "." .$Variable3 . ".value='" . $Valeur3 . "';";
          $texte .= "document.forms." . $this->NomFormulaire . "." .$Variable4 . ".value='" . $Valeur4 . "';";
          $texte.="document.forms." . $this->NomFormulaire .".submit()\"";
          $texte .= "/>";
        }
        return $texte;
    }
    
    // Insert un champs hidden pour permettre les validations par lien.
    function AjouteChampHidden($Variable, $Valeur)
    {
        return $this->AjouteChampInput("INPUT", $Variable, "", "hidden", $Valeur, "", "","", "N", "N", "N","");
    }

    function ValidationParLien($Texte)
    {
        return "<a href=\"javascript:document.forms." . $this->NomFormulaire .".submit()\">" . $Texte . "</a>";
    }

    function ValidationParLien1Champ($Texte, $Variable1, $Valeur1)
    {
        return "<a href=\"javascript:document.forms." . $this->NomFormulaire . "." . $Variable1 .".value='" . $Valeur1 . "';document.forms." . $this->NomFormulaire . ".submit()\">" . $Texte . "</a>";
    }

    function ValidationParLien2Champs($Texte, $Variable1, $Valeur1, $Variable2, $Valeur2)
    {
        return "<a href=\"javascript:document.forms." . $this->NomFormulaire . "." . $Variable1 . ".value='" . $Valeur1 . "';document.forms." . $this->NomFormulaire . "." . $Variable2 . ".value='" . $Valeur2 . "';document.forms." . $this->NomFormulaire . ".submit()\">" . $Texte . "</a>";
    }

    function ValidationParLien3Champs($Texte, $Variable1, $Valeur1, $Variable2, $Valeur2, $Variable3, $Valeur3)
    {
        return "<a href=\"javascript:document.forms." . $this->NomFormulaire . "." . $Variable1 .
            ".value='" . $Valeur1 . "';document.forms." . $this->NomFormulaire . "." . $Variable2 .
            ".value='" . $Valeur2 . "';document.forms." . $this->NomFormulaire . "." . $Variable3 .
            ".value='" . $Valeur3 . "';document.forms." . $this->NomFormulaire . ".submit()\">" .
            $Texte . "</a>";
    }

    function ValidationParLien4Champs($Texte, $Variable1, $Valeur1, $Variable2, $Valeur2,
        $Variable3, $Valeur3, $Variable4, $Valeur4)
    {
        return "<a href=\"javascript:document.forms." . $this->NomFormulaire . "." . $Variable1 .
            ".value='" . $Valeur1 . "';document.forms." . $this->NomFormulaire . "." . $Variable2 .
            ".value='" . $Valeur2 . "';document.forms." . $this->NomFormulaire . "." . $Variable3 .
            ".value='" . $Valeur3 . "';document.forms." . $this->NomFormulaire . "." . $Variable4 .
            ".value='" . $Valeur4 . "';document.forms." . $this->NomFormulaire . ".submit()\">" .
            $Texte . "</a>";
    }

    function FormLienFin()
    {
        if ($this->Methode != "")
            return "</form>";
        else
            return "";
    }

    // *************************
    // Liens classiques.
    // *************************
    function FaitLienRetourPage($t)
    {
        return '<a href="javascript:history.go(-1)">' . $t . '</a>';
    }

    function FaitLienHTML($UrlPage, $Texte)
    {
        return '<a href="' . $UrlPage . '">' . $Texte . "</a>";
    }

    function RedirectionURL($Url)
    {
        return "<script type=\"text/javascript\">document.location.href=\"" . $Url . "\"</script><noscript>";
    }

    function RedirectionURLTempo($Url,$NbSeconde)
    {
        return "<script type=\"text/javascript\">window.setTimeout(\"document.location.href=('".$Url."');\",".($NbSeconde*1000)."); </script>";
    }
    // ****************************
    // Gestion d'un tableau
    // ****************************
    // Debut de Tableau
    function TableauDebut($LeTexte, $LargeurTableau, $Pourcentage, $Border)
    {
        $texte = "";
        if ($Pourcentage != "")
            $d = explode(",", $Pourcentage);
        $texte = "<table width=\"$LargeurTableau\" border=\"$Border\">";
        if ($LeTexte != "") {
            $texte .= "<tr>";
            if ($Pourcentage == "")
                for ($i = 0; $i < count($LeTexte); $i++)
                    $texte .= '<td>' . $LeTexte[$i] . '</td>';
                else
                    for ($i = 0; $i < count($LeTexte); $i++)
                        $texte .= '<td width="' . $d[$i] . '">' . $LeTexte[$i] . '</td>';
            $texte .= "</tr>";
        }
        return $texte;
    }

    // Contenus de Tableau
    function TableauContenu($LeTexte, $Pourcentage = "")
    {
        $texte = "";
        if ($Pourcentage != "")
            $d = explode(",", $Pourcentage);
        $texte .= "<tr>";
        if ($Pourcentage == "") {
            for ($i = 0; $i < count($LeTexte); $i++) {
                $texte .= '<td nowrap>';
                $texte .= $LeTexte[$i];
                $texte .= '</td>';
            }
        } else {
            for ($i = 0; $i < count($LeTexte); $i++) {
                $texte .= '<td width="' . $d[$i] . '" nowrap>';
                $texte .= $LeTexte[$i];
                $texte .= '</td>';
            }
        }
        $texte .= "</tr>";
        return $texte;
    }

    // Fin de Tableau
    function TableauFin()
    {
        return "</table>";
    }
    // ****************************
    // Fin de Tableau
    // ****************************

    //*************************************
    // Gestion des listes déroulantes select
    //*************************************
    function FormSelectDebut($NomSelect, $Taille, $Multiple, $Grise)
    {
        $texte = "";
        $texte = "<select size=\"$Taille\" name=\"$NomSelect\"";
        if ($Multiple == "O")
            $texte .= " multiple";
        if ($Grise == "O")
            $texte .= " disabled";
        $texte .= ">";
        return $texte;
    }

    // Enrichi le select
    function FormSelectOption($Nom, $Valeur, $Checked)
    {
        $texte = "";
        $texte = "<option value=\"$Valeur\"";
        if ($Checked == "O")
            $texte .= " SELECTED ";
        $texte .= ">$Nom</option>";
        return $texte;
    }

    // Fin de select
    function FormSelectFin()
    {
        $texte = "";
        $texte = "</select>";
        return $texte;
    }
}